package de.jottyfan.bico.modules.sheet;

import static de.jottyfan.bico.db.Tables.V_CALENDAR;

import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.jooq.DSLContext;
import org.jooq.SelectSeekStep1;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import de.jottyfan.bico.db.tables.records.VCalendarRecord;
import de.jottyfan.bico.modules.sheet.model.SheetBean;

/**
 *
 * @author jotty
 *
 */
@Repository
public class SheetRepository {

	private static final Logger LOGGER = LogManager.getLogger(SheetRepository.class);

	@Autowired
	private DSLContext jooq;

	public List<SheetBean> getList() {
		SelectSeekStep1<VCalendarRecord, LocalDate> sql = jooq.selectFrom(V_CALENDAR).orderBy(V_CALENDAR.SLOT_DAY);
		LOGGER.trace(sql.toString());
		List<SheetBean> list = new ArrayList<>();
		for (VCalendarRecord r : sql.fetch()) {
			SheetBean bean = new SheetBean();
			bean.setAbbreviation(r.getAbbreviation());
			bean.setBibleverse(r.getBibleverse());
			bean.setBookPages(r.getBookPages());
			bean.setFullname(r.getFullname());
			bean.setLessonNotes(r.getLessonNotes());
			bean.setSlotDay(r.getSlotDay());
			bean.setSlotNotes(r.getSlotNotes());
			bean.setSourceName(r.getSourceName());
			bean.setSubjectNotes(r.getSubjectNotes());
			bean.setSubtheme(r.getSubtheme());
			bean.setTheme(r.getTheme());
			bean.setWorksheets(r.getWorksheets());
			list.add(bean);
		}
		return list;
	}
}
